#ifndef _positioner_h_
#define _positioner_h_

#ifndef WIN32
#include <vector.h>
#include <map.h>
#else
#include <vector>
#include <map>
using namespace std;
#endif
#include "valuator.h"

typedef struct pointData_ pointData;

typedef vector<pointData*> pointList;
    

#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_positioner_MODULE_DLL_API 
#endif

class YG_positioner_MODULE_DLL_API positioner : public valuator
    {
    public:
     positioner(const char* name,bool master=true);
     ~positioner(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
    private:
     static struct _positionerPrivateData* p_;
     static pointList* listReference(const ygString&);
     static pointList* loadPointList(const ygString& file);
     void calcAvgDistance(void);
     float averageDist;
     float scaleFactor;
     pointData* lastPoint;
     pointList* points;
     ygString filename;
    };


#endif
