#ifndef _quadparts_h_
#define _quadparts_h_

#include "ygNode.h"
#include "ygString.h"
#include <Performer/pr/pfGeoMath.h>


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_quadparts_MODULE_DLL_API 
#endif

class YG_quadparts_MODULE_DLL_API quadparts : public ygNode
    {
    public:
     quadparts(const char* name,bool master=true);
     ~quadparts(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
             void loadTex(const ygString&);
    private:
     pfBox range_;
     int numParticles_;
     class pfGeoSet *gset_;
     pfVec3 *verts_;
     int nextParticle_;
     float size_;
     float speed_;
     pfTexture *tex_;
     bool firstFrame_;
     void createGeode(void);
     void initParticle(int npart);
    };


#endif
