#ifndef _sceneGraph_h_
#define _sceneGraph_h_

#include "ygNode.h"


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_sceneGraph_MODULE_DLL_API 
#endif

class YG_sceneGraph_MODULE_DLL_API sceneGraph : public ygNode
    {
    public:
     sceneGraph(const char* name,bool master=true);
     ~sceneGraph(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
    private:
     void checkSelect(void);
     void buildGraph(void);
	 float buildNode(ygNode*,int);
     pfGeode* createConnection(int);
     ygString nodeName;
     ygString lastNode;
     ygString selectName;
     ygString lastSelect;
     ygNode* node;
     float width;
     float height;
	 int depth;
     std::vector<pfDCS*> nodes;
     std::vector<pfGeode*> connections;
     pfVec3* vertices;
     pfVec4* color;
     pfGeoState* gstate;
     int numVertices;
     int numNodes;
     int currVertex;
     int currNum;
     int currConn;
    };


#endif
