#ifndef _value_h_
#define _value_h_

#include "ygNode.h"
#include <vector>


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_value_MODULE_DLL_API 
#endif

class YG_value_MODULE_DLL_API value : public ygNode
    {
    public:
     value(const char*,bool master=true);
     ~value(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
     virtual void appTraverse(void);
     float getValue(int element=0) const;
     float getLastValue(int element=0) const;
     int getSize() const;
     void setValue(const float& ivalue,int element=0);
    protected:
     virtual void createDebugNode(void);
     bool isChanged(void);
     void clampValues(void);
     ygString getArguments(ygString args="");
     virtual void setValueSize(int);
     void setSize(std::vector<float>&,int,int,float=0.0);
     std::vector<float> values;
     std::vector<float> lastValues;
     int size;
     std::vector<float> deltas;
     std::vector<float> minimums;
     std::vector<float> maximums;
     bool integer;
     ygString refNode;
     value* reference;
    };

#endif
