#ifndef _ygDSOLoader_h_
#define _ygDSOLoader_h_

#include <map>
#include "ygString.h"
class ygNode;

#ifdef WIN32
typedef ygNode * (APIENTRY *ygNodeConstructorPtr)(const char*,bool);
#else
typedef ygNode * (*ygNodeConstructorPtr)(const char*,bool);
#endif

#include "ygWand.h"

#include "ygDLL.h"

class YG_DLL_API ygDSOLoader
    {
    public:
     static void init(void);
     static ygNodeConstructorPtr getNodeConstructor(const ygString&);
     static void addConstructor(const ygString& name,ygNodeConstructorPtr constructor);
     static const std::map<ygString,class ygDSOInfo*>& getDSOInfoMap(void);
    private:
     static void addBuiltinConstructors(void);
     static void preLoadClasses(const ygString &classes);
     static void searchForDSOs(void);
     static void searchDirectory(const ygString& dirname);
     static bool loadDSO(class ygDSOInfo *info);
     static bool loadDSODependencies(const class ygDSOInfo *info);
     static bool loadYgdepFileDependencies(const class ygDSOInfo *info);
     static bool loadStringTagDependencies(const class ygDSOInfo *info);
     static struct _ygDSOLoaderPrivateData * p_;
    };


#endif
