#ifndef _ygParser_h_
#define _ygParser_h_

#include "ygString.h"
#include <map>
#include <list>

using namespace std;

class ygNode;
class ygTokenStream;
class ygMessage;

#include "ygDLL.h"

#ifdef WIN32
#ifdef _MSC_VER
#pragma warning(push)
#pragma warning(disable: 4251 4800 4267 4018)
#endif // _MSC_VER
#endif

class YG_DLL_API ygParser
    {
    public:
     ygParser(void);
     void clear(void);
     void parseFile(const ygString&,ygNode*,bool preprocess=true);
     void replaceInitMessages(ygNode*);
     void replaceMessageName(ygMessage*);
    private:
     list<ygNode*> nodeList;
     map<ygString,ygString> replaceMap;
     ygNode * parseNode(const ygString&,ygTokenStream*);
     void parseInitMessages(ygNode *,ygString&);
    };

#if defined(WIN32) && defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif
