#ifndef _ygScene_h_
#define _ygScene_h_

#include <vector>
#include <set>
#include "ygParser.h"
#include "ygNode.h"

using namespace std;

#include "ygDLL.h"

#ifdef WIN32
#ifdef _MSC_VER
#pragma warning(push)
#pragma warning(disable: 4251 4800 4267 4018)
#endif // _MSC_VER
#endif

class YG_DLL_API ygScene : public ygNode
    {
    public:
     ygScene(const char* name,bool master=true);
     ~ygScene(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void parseMessage(const ygMessage&,bool force=false);
     virtual void printMessages(std::ostream&,int indent=0,bool comment=false);
    private:
     void loadFile(const ygString&,bool preprocess);
     ygParser parser;
     bool preprocess;
     bool first;
     bool loaded;
     bool reload;
     ygString filename;
     vector<ygString> initMessages;
     set<ygNode*> sceneChildren;
    };

extern "C" YG_DLL_API ygNode* APIENTRY construct_ygScene(const char*,bool);

#if defined(WIN32) && defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif
