#ifndef _ygTexture_h
#define _ygTexture_h

#include <Performer/pf/pfGeode.h>
#include "ygGeometry.h"

#include "ygDLL.h"

class YG_DLL_API ygTexture : public ygGeometry
{
    public:
     ygTexture(const char *name, bool master = true);
     ~ygTexture(void);
     virtual void reset(void);
     virtual void message(const ygMessage &);
     void setTexture(const ygString&);
     void setFilter(int);
     void setClamp(bool);
    protected:
     virtual void createDebugNode(void);
    private:
     void createTransform(void);
     void createGeometry(void);
     ygNode* transform;
     bool cache,curCache;
     bool show;
     pfGeode* geode;
     pfGeoSet* geoset;
     pfGeoState* gstate;
     ygString filename;
};

extern "C" YG_DLL_API ygNode* APIENTRY construct_ygTexture(const char*,bool);

#endif
